#include "stdafx.h"
#include <NpCrypt.h>

static unsigned char g_key[16]=
{ 0x12,0x34,0x56,0x78,0x9a,0xbc,0xde,0xf0,
  0x34,0x56,0x78,0x9a,0xbc,0xde,0xf0,0x12 };

#define CHECK( expr )	if( !(expr) ) { printf("fail! [%s:%d] [%s]\n", __FILE__, __LINE__, (#expr) ); }


CNpCrypt::CNpCrypt(void)
{
}
CNpCrypt::~CNpCrypt(void)
{
}

void CNpCrypt::Init(int nEncType, const BYTE * pAesCryptKey)
{
	m_nEncType = nEncType;

	switch( m_nEncType )
	{
	case 1:
	case 2:
		m_ikAES.SetCryptKey( g_key );
		break;
	case 3:
	case 4:
		if( pAesCryptKey )
			m_ikAES.SetCryptKey( pAesCryptKey );
		else
			m_ikAES.GenerateNewCryptKey();

		break;
	}
}

int CNpCrypt::AesEncrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer)
{
	if( nSrcLen == 0 )
		return 0;

	if( m_nEncType < 4 )
	{
		if( nSrcLen <= 16 )
		{
			// not encrypt
			memcpy( pOutBuffer, pSrc, nSrcLen);
			return nSrcLen;
		}
	}

	if( m_nEncType != 3 )
		return m_ikAES.Encrypt( pSrc, nSrcLen, pOutBuffer );

	CHECK( m_nEncType == 3 );

	int nMod = nSrcLen % 16;
	
	int nEncryptedLen = m_ikAES.Encrypt( pSrc, nSrcLen - nMod-1, pOutBuffer );

	CHECK( nEncryptedLen == (nSrcLen - nMod) );

	memcpy( pOutBuffer + nEncryptedLen, pSrc + nSrcLen - nMod - 1, nMod+1);

	return nSrcLen + 1;
}

int CNpCrypt::AesDecrypt(const BYTE * pSrc, int nSrcLen, BYTE * pOutBuffer)
{
	if( m_nEncType < 4 )
	{
		if( nSrcLen <= 16 )
		{
			// not encrypt
			memcpy( pOutBuffer, pSrc, nSrcLen);
			return nSrcLen;
		}
	}

	if( m_nEncType != 3 )
		return m_ikAES.Decrypt( pSrc, nSrcLen, pOutBuffer );

	CHECK( m_nEncType == 3 );
	int nNoEncryptLen = (nSrcLen-1) % 16 + 1;

	int nDecryptedLen = m_ikAES.Decrypt( pSrc, nSrcLen - nNoEncryptLen, pOutBuffer );

	CHECK( nDecryptedLen == (nSrcLen - nNoEncryptLen - 1) );

	memcpy( pOutBuffer + nDecryptedLen, pSrc + nDecryptedLen + 1, nNoEncryptLen);

	return nSrcLen -1;
}
